/*
 * Copyright (C) 2008 Luke Kenneth Casson Leighton <lkcl@lkcl.net>
 * Copyright (C) 2008 Alp Toker <alp@atoker.com>
 * Copyright (C) 2008 Apple Inc.
 */
#ifndef __GdomTreeWalker_H__
#define __GdomTreeWalker_H__
#include <webkit/webkitdefines.h>
#include "gdom/GdomDOMObject.h"
#include "gdom/GdomNode.h"
#include "glib-object.h"


G_BEGIN_DECLS

typedef struct _GdomTreeWalker GdomTreeWalker;
typedef struct _GdomTreeWalkerClass GdomTreeWalkerClass;


#define GDOM_TYPE_TREE_WALKER            (gdom_tree_walker_get_type())
#define GDOM_TREE_WALKER(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), GDOM_TYPE_TREE_WALKER, GdomTreeWalker))
#define GDOM_TREE_WALKER_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  GDOM_TYPE_TREE_WALKER, GdomTreeWalker)Class)
#define GDOM_IS_TREE_WALKER(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), GDOM_TYPE_TREE_WALKER))
#define GDOM_IS_TREE_WALKER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  GDOM_TYPE_TREE_WALKER))
#define GDOM_TREE_WALKER_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  GDOM_TYPE_TREE_WALKER, GdomTreeWalkerClass))

typedef struct _GdomTreeWalkerPrivate GdomTreeWalkerPrivate;

struct _GdomTreeWalker {
    GdomDOMObject parent_instance;
    GdomTreeWalkerPrivate *priv;
};

struct _GdomTreeWalkerClass {
    GObjectClass parent_class;
};

WEBKIT_API GType
gdom_tree_walker_get_type (void);


/* XXX TODO: custom function gdom_tree_walker_parent_node */


/* XXX TODO: custom function gdom_tree_walker_first_child */


/* XXX TODO: custom function gdom_tree_walker_last_child */


/* XXX TODO: custom function gdom_tree_walker_previous_sibling */


/* XXX TODO: custom function gdom_tree_walker_next_sibling */


/* XXX TODO: custom function gdom_tree_walker_previous_node */


/* XXX TODO: custom function gdom_tree_walker_next_node */

G_END_DECLS

#endif /* __GdomTreeWalker_H__ */
